%-----------------------------------------------------------------------
%  starting.m
% 
%------------------------------------------------------------------------
%
% This file is used to generate the data A in the Lorentz eigenvalue problem 
%  
%   x\in\K, Ax - lamd*x \in K,  <x, Ax - lamd*x>=0, 
%
% and the starting point (x0,y0,lamd0) randomly


function [x0,y0,lamd0] = starting(n,nq,A);

x0 = zeros(n,1);  

nk = n/nq;

for j = 1:nq
    
    x1 = rand(nk,1);    
    
  %  x0((j-1)*nk+1:j*nk)= -ones(nk,1) + 2*x1; 
    
   x0((j-1)*nk+1:j*nk)= -100*ones(nk,1) + 200*x1; 
  
    
end   

lamd0 = (x0'*(A*x0))/(x0'*x0);

y0 =A*x0-lamd0*x0;

