%-----------------------------------------------------------------------
%  starting.m
% 
%------------------------------------------------------------------------
%
% This file is used to generate the data A in the Lorentz eigenvalue problem 
%  
%   x\in\K, Ax - lamd*x \in K,  <x, Ax - lamd*x>=0, 
%



function [A,n,nr] = data(nq);

global A nr;

% generate a random vector xi with uniform distribution on [-1,1]^n

n =3*nq;

A = zeros(n,n);

nk = n/nq;
   
nr = zeros(nq+1,1);

nr(1) = 1;

for i = 1:nq;

     nr(i+1) = nr(i) + nk;
   
end

%------------------------For the Lyapunov-tranformation  ------------------------------------ 

%a = zeros(n,1);  

%xa = zeros(nk,1);

% for j = 1:nq
  
 %   a((j-1)*nk+1:j*nk)= -1*ones(nk,1) + 2*rand(nk,1); 
    
 %   xa =a((j-1)*nk+1:j*nk);
      
 %   A((j-1)*nk+1:j*nk,(j-1)*nk+1:j*nk) = [xa(1)  xa(2:end)'; xa(2:end)  xa(1)*eye(nk-1)];
    
 %end   

%----------------------For the Stein transformation  -------------------------------------------  

%a = zeros(n,1);  

%xa = zeros(nk,1);

% for j = 1:nq
  
 %   a((j-1)*nk+1:j*nk)= -1*ones(nk,1) + 2*rand(nk,1); 
    
 %   xa =a((j-1)*nk+1:j*nk);
  
 %   A1 = [xa(1)  xa(2:end)'; xa(2:end)  xa(1)*eye(nk-1)];
    
 %   A((j-1)*nk+1:j*nk,(j-1)*nk+1:j*nk) =2*A1*A1-[xa'*xa  2*xa(1)*xa(2:end)'; 2*xa(1)*xa(2:end) (xa'*xa)*eye(nk-1)]; 
    
 %end   
 
% A = eye(n) - A;



%--------------------- For the symmetric transformation -----------------------------   
% for j = 1:nq
            
 %    A1 = -ones(nk,nk) + 2*rand(nk,nk);
   
%     A((j-1)*nk+1:j*nk,(j-1)*nk+1:j*nk) =(A1+A1')/2;

%end


%--------------------- For the asymmetric transformation -----------------------------   
  for j = 1:nq
            
     A1 = -ones(nk,nk) + 2*rand(nk,nk);
   
    % A((j-1)*nk+1:j*nk,(j-1)*nk+1:j*nk) = A1;
 
end

 
